

; simple "add me" to the tool menu in ScITE
; by argumentum, but if anything goes wrong, don't blame me.


If Not FileExists(@ScriptDir & "\ScriptOMaticANSI.exe") Then
	MsgBox(262144, @ScriptName, 'this should not have happened,' & @CR & @CR & 'I can''t find "ScriptOMaticANSI.exe"                                        ', 60)
	Exit
EndIf

Local $s__SciteRoot = ""
If StringInStr($CmdLineRaw, "/ErrorStdOut") Then ; run from within ScITE ( best if in portable setup )
	$s__SciteRoot = GetMeSciteExePath()
Else ; else, rely that ScITE is a subFolder of AutoIt ( as is default )
	$s__SciteRoot = StringLeft(@AutoItExe, StringInStr(@AutoItExe, "\", 0, -1)) & "SciTE\"
EndIf

Local $a__Au3_PropertiesFile = $s__SciteRoot & "properties\au3.properties"
Local $s__Au3_Properties = FileRead($a__Au3_PropertiesFile)
If Not StringInStr($s__Au3_Properties, "command.shortcut.") Then
	$a__Au3_PropertiesFile = $s__SciteRoot & "menu\menu.properties"
	$s__Au3_Properties = FileRead($a__Au3_PropertiesFile)
EndIf
If Not StringInStr($s__Au3_Properties, "command.shortcut.") Then
	$s__Au3_Properties = ""
	$a__Au3_PropertiesFile = ""
	MsgBox(262144, @ScriptName, "failed to find where to put the settings at !                                          ", 60)
	Exit
EndIf
If StringInStr($s__Au3_Properties, "WMI ScriptOMatic") Then
	MsgBox(262144, @ScriptName, '"WMI ScriptOMatic" was found in the properties file,' & @CR & @CR & 'it''s safe to assume that is already installed.                                         ', 60)
	Exit
EndIf
If StringInStr($s__Au3_Properties, "=Ctrl+Alt+W") Or StringInStr($s__Au3_Properties, "=Alt+Ctrl+W") Then
	MsgBox(262144, @ScriptName, 'the shortcut "Ctrl+Alt+W" is already taken,' & @CR & @CR & 'it''s not safe to add this entry.                                         ', 60)
	Exit
EndIf
Local $aPropertiesFile = StringSplit($s__Au3_Properties, @CRLF, 1)
Local $iNew = 0
For $n = 1 To $aPropertiesFile[0]
	If StringInStr($aPropertiesFile[$n], "FD.exe") Then
		Local $b = StringSplit($aPropertiesFile[$n], ".")
		If UBound($b) > 2 Then
			$iNew = $b[2]
			Do
				$iNew += 1
			Until Not StringInStr($s__Au3_Properties, "command.name." & $iNew & ".")
		EndIf
	EndIf
	If $iNew Then
		Local $sLeft = StringLeft(StringStripWS($aPropertiesFile[$n], 3), 1)
		If $sLeft = "" Or $sLeft = "#" Then
			Local $sNew = ""
			Switch $a__Au3_PropertiesFile
				Case $s__SciteRoot & "properties\au3.properties" ; standard ScITE distro. ; https://www.autoitscript.com/site/autoit-script-editor/downloads/
					$sNew &= '# ' & $iNew & ' WMI ScriptOMatic' & @CRLF
					$sNew &= 'command.' & $iNew & '.$(au3)="$(SciteDefaultHome)\Tools\ScriptOMatic\ScriptOMaticANSI.exe" /Scite' & @CRLF
					$sNew &= 'command.subsystem.' & $iNew & '.$(au3)=1' & @CRLF
					$sNew &= 'command.name.' & $iNew & '.$(au3)=WMI ScriptOMatic' & @CRLF
					$sNew &= 'command.shortcut.' & $iNew & '.$(au3)=Ctrl+Alt+W' & @CRLF
					$sNew &= 'command.quiet.' & $iNew & '.$(au3)=1' & @CRLF
					$sNew &= 'command.save.before.' & $iNew & '.$(au3)=2' & @CRLF
				Case $s__SciteRoot & "menu\menu.properties" ; Yashied ScITE ; https://www.autoitscript.com/forum/topic/167992-scite-32599-compiler-wrapper/
					$sNew &= @CRLF
					$sNew &= '	command.separator.' & $iNew & '.$(au3)=1' & @CRLF
					$sNew &= '	command.parent.' & $iNew & '.$(au3)=1' & @CRLF
					$sNew &= '	command.name.' & $iNew & '.$(au3)=WMI ScriptOMatic' & @CRLF
					$sNew &= '	command.' & $iNew & '.$(au3)="$(SciteDefaultHome)\Tools\ScriptOMatic\ScriptOMaticANSI.exe" /Scite' & @CRLF
					$sNew &= '	command.mode.' & $iNew & '.$(au3)=subsystem:shellexec,savebefore:no,quiet:no' & @CRLF
					$sNew &= '	command.shortcut.' & $iNew & '.$(au3)=Ctrl+Alt+W' & @CRLF
				Case Else
					MsgBox(262144, @ScriptName, 'this should not have happened,' & @CR & 'so better quit  =(                                         ' & @CR & @ScriptLineNumber & @CR & $a__Au3_PropertiesFile, 60)
					Exit
			EndSwitch
			$aPropertiesFile[$n] = $sNew & $aPropertiesFile[$n]
			$iNew = 0
		EndIf
	EndIf
Next

Local $sRebuild = ""
For $n = 1 To $aPropertiesFile[0]
	$sRebuild &= $aPropertiesFile[$n] & @CRLF
Next
Local $sBak = $a__Au3_PropertiesFile & "." & @HOUR & @MIN & @SEC & ".bak"
If FileMove($a__Au3_PropertiesFile, $sBak) Then
	If FileWrite($a__Au3_PropertiesFile, $sRebuild) Then
		If Not FileCopy("ScriptOMaticANSI.exe", $s__SciteRoot & "Tools\ScriptOMatic\ScriptOMaticANSI.exe", 9) Then
			MsgBox(262144, @ScriptName, 'this should not have happened,' & @CR & @CR & '"ScriptOMaticANSI.exe" copy failed' & @CR & @CR & "please copy it manually, thanks", 60)
			Exit
		EndIf
		MsgBox(262144, @ScriptName, 'great, now close ScITE and open it.' & @CR & @CR & 'WMI ScriptOMatic should be seen in the menu.                                        ', 60)
	Else
		FileMove($sBak, $a__Au3_PropertiesFile)
		MsgBox(262144, @ScriptName, 'something went wrong.' & @CR & @CR & 'the BAK file should have been restored.                                        ', 60)
	EndIf
EndIf

Func GetMeSciteExePath()
	Local $wbemFlagReturnImmediately = 0x10
	Local $wbemFlagForwardOnly = 0x20
	Local $colItems = ""
	Local $sComputer = "localhost"
	Local $sReturn = ""
	Local $oWMIService = ObjGet("winmgmts:\\" & $sComputer & "\root\CIMV2")
	Local $colItems = $oWMIService.ExecQuery("SELECT ExecutablePath FROM Win32_Process where name='scite.exe'", _
			"WQL", $wbemFlagReturnImmediately + $wbemFlagForwardOnly)
	If IsObj($colItems) Then
		Local $iCounter = 0
		For $objItem In $colItems
			Return StringTrimRight($objItem.ExecutablePath, StringLen("scite.exe"))
		Next
	Else
		Return $s__SciteRoot = StringLeft(@AutoItExe, StringInStr(@AutoItExe, "\", 0, -1)) & "SciTE\"
		;MsgBox(262144, "WMI Output", "No WMI Objects Found for class: " & "Win32_Process")
	EndIf
	Return ""
EndFunc   ;==>GetMeSciteExePath
