#cs ----------------------------------------------------------------------------

	AutoIt Version: 3.2.12.1
	Author:         myName

	Script Function:
	Template AutoIt script.

#ce ----------------------------------------------------------------------------

; Script Start - Add your code below here

#include-once
#include <WinAPI.au3>

Global $user32dll = DllOpen("user32.dll")

#Region Scintilla.h
; many Scintilla.h around, took what I needed =/
Global Const $SCI_SETMARGINWIDTHN = 2242
Global Const $SCI_TEXTWIDTH = 2276
Global Const $STYLE_LINENUMBER = 33
Global Const $MARGIN_SCRIPT_FOLD_INDEX = 1
Global Const $SCI_SETLEXER = 4001
Global Const $STYLE_DEFAULT = 32
Global Const $SCI_STYLESETFORE = 2051
Global Const $SCI_STYLESETBACK = 2052
Global Const $SCI_STYLESETITALIC = 2054
Global Const $SCI_STYLESETBOLD = 2053
Global Const $SCI_STYLESETUNDERLINE = 2059
Global Const $SCI_SETKEYWORDS = 4005
Global Const $SCI_SETTABWIDTH = 2036
Global Const $SCI_SETBUFFEREDDRAW = 2035
Global Const $SCI_SETMARGINTYPEN = 2240
Global Const $SC_MARGIN_SYMBOL = 0
Global Const $SCI_SETMARGINMASKN = 2244
Global Const $SC_MASK_FOLDERS = -33554432
Global Const $SCI_MARKERDEFINE = 2040
Global Const $SC_MARKNUM_FOLDER = 30
Global Const $SC_MARK_PLUS = 8
Global Const $SC_MARKNUM_FOLDEROPEN = 31
Global Const $SC_MARK_MINUS = 7
Global Const $SC_MARKNUM_FOLDEREND = 25
Global Const $SC_MARK_EMPTY = 5
Global Const $SC_MARKNUM_FOLDERMIDTAIL = 27
Global Const $SC_MARKNUM_FOLDEROPENMID = 26
Global Const $SC_MARKNUM_FOLDERSUB = 29
Global Const $SC_MARKNUM_FOLDERTAIL = 28
Global Const $SCI_SETFOLDFLAGS = 2233
Global Const $SCI_SETMARGINSENSITIVEN = 2246
Global Const $SCMOD_CTRL = 2
Global Const $SCMOD_SHIFT = 1
Global Const $SCI_STYLECLEARALL = 2050
Global Const $SCI_GETSTYLEBITSNEEDED = 4011
Global Const $SCI_SETSTYLEBITS = 2090
Global Const $SCI_STYLESETSIZE = 2055
Global Const $SCI_STYLESETFONT = 2056
Global Const $SCI_CLEARCMDKEY = 2071
Global Const $SCI_SETPROPERTY = 4004
Global Const $SCI_APPENDTEXT = 2282
Global Const $SCI_CLEARALL = 2004
Global Const $SCI_GETTEXT = 2182

#EndRegion Scintilla.h

;~ Global Const $SWP_SHOWWINDOW = 64 ; for _WinAPI_SetWindowPos()
;~ Global Const $SWP_HIDEWINDOW = 128
;~ Global Const $GUI_RUNDEFMSG = "GUI_RUNDEFMSG"
;~ Global Const $WS_CHILD = 1073741824
;~ Global Const $WS_HSCROLL = 1048576
;~ Global Const $WS_VSCROLL = 2097152
;~ Global Const $WS_TABSTOP = 65536
;~ Global Const $WS_CLIPCHILDREN = 33554432
;~ Global Const $WS_EX_STATICEDGE = 131072
;~ Global Const $GUI_DOCKLEFT = 2
;~ Global Const $GUI_DOCKRIGHT = 4
;~ Global Const $GUI_DOCKTOP = 32
;~ Global Const $GUI_DOCKBOTTOM = 64
;~ Global Const $GUI_HIDE = 32

Global $aSciLexer[9]

Global $id_StatusBar = 0 ; just to avoid the "warning: $id_StatusBar: possibly used before declaration."
Func WM_SIZE($hWnd, $iMsg, $iwParam, $ilParam)
	#forceref $hWnd, $iMsg, $iWParam, $ilParam
	_SendMessage( $id_StatusBar , 0x05 ) ; to resize the status bar but not part of the "UDF"
	If Int($aSciLexer[0]) Then __SciLexer_Resize()
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_SIZE

Func __SciLexer_Resize($swp=64)
	Local $a = ControlGetPos(GUICtrlGetHandle($aSciLexer[3]), "", 0)
	If UBound($a) = 4 Then _WinAPI_SetWindowPos($aSciLexer[0], 0, $a[0], $a[1], $a[2], $a[3], $swp) ; $SWP_SHOWWINDOW = 64 ; $SWP_HIDEWINDOW = 128
	DllCall("user32.dll", "int", "RedrawWindow", "hwnd", $aSciLexer[0], "int", 0, "int", 0, "int", 1)
EndFunc   ;==>__SciLexer_Resize

Func __SciLexer_SetData($Sci, $sData)
	SciClearAll($Sci)
	SciAppendText($Sci, $sData)
EndFunc   ;==>__SciLexer_SetData

Func __SciLexer_Create($hParent, $iX, $iY, $iCX, $iCY)
	Local $aSciLexer[9]
	$aSciLexer[0] = 0
	Local $sSciLexer_dll = __SciLexer_Find_SciTEfile("\ScITE\SciLexer.dll", @ScriptDir)
	If @error Then $sSciLexer_dll = __SciLexer_Find_SciTEfile("\ScITE\SciLexer.dll", EnvGet("ProgramFiles(x86)") & "\AutoIt3")
	If @error Then $sSciLexer_dll = __SciLexer_Find_SciTEfile("\ScITE\SciLexer.dll", EnvGet("ProgramFiles") & "\AutoIt3")
	If @error Then Return SetError(1, 0, $aSciLexer)
	Local $hLibrary = _WinAPI_LoadLibrary($sSciLexer_dll)
	If @error Then Return SetError(2, @extended, $aSciLexer)
	Local $SciStyle = BitOR($WS_CHILD, $WS_HSCROLL, $WS_VSCROLL, $WS_TABSTOP, $WS_CLIPCHILDREN); style used by the scintilla control
	Local $SciStyleEx = $WS_EX_STATICEDGE ; $WS_EX_CLIENTEDGE; give it a sunken looking border
	Local $hSciLexer = _WinAPI_CreateWindowEx($SciStyleEx, "Scintilla", "SciLexerForScriptomatic", $SciStyle, 1, 1, 100, 100, $hParent)
	If @error Then Return SetError(3, @extended, $aSciLexer)
	If Not _WinAPI_SetWindowPos($hSciLexer, 0, $iX, $iY, $iCX, $iCY, 64) Then Return SetError(4, @extended, $aSciLexer)
	$aSciLexer[0] = $hSciLexer ; handle to the new window
	$aSciLexer[1] = $hLibrary ; handle of the dll
	$aSciLexer[2] = $sSciLexer_dll ; path to the dll

	$aSciLexer[3] = GUICtrlCreateEdit("", $iX, $iY, $iCX, $iCY)
	GUICtrlSetResizing($aSciLexer[3], $GUI_DOCKLEFT + $GUI_DOCKRIGHT + $GUI_DOCKTOP + $GUI_DOCKBOTTOM)
	GUICtrlSetState($aSciLexer[3], $GUI_HIDE) ; Control will not be visible. Is to be used to resize $aSciLexer[0]

	$aSciLexer[4] = 1 ; show line numbers on
	SendMessage($aSciLexer[0], $SCI_SETMARGINWIDTHN, 0, SendMessageString($aSciLexer[0], $SCI_TEXTWIDTH, $STYLE_LINENUMBER, "999999"));

	$aSciLexer[5] = 1 ; show folds on
	SendMessage($aSciLexer[0], $SCI_SETMARGINWIDTHN, $MARGIN_SCRIPT_FOLD_INDEX, 20);
	;$aSciLexer[5] = 0 ; show folds off
	;SendMessage($aSciLexer[0],$SCI_SETMARGINWIDTHN, $MARGIN_SCRIPT_FOLD_INDEX, 0);

;~ 	InitEditor($aSciLexer[0])
	Local $default_style = "0x000000,0xFFFFFF,10,Courier New,0,0,0"
	Local $default_style = "0x000000,0xFFFFFF,10,Terminal,0,0,0"
;~ 	SetStyle($aSciLexer[0], $STYLE_DEFAULT, $default_style)

;~ 	LoadHiglight("highlighter.au3.txt",$aSciLexer[0] )


	SendMessage($aSciLexer[0], $SCI_SETLEXER, 60, 0) ; $SCLEX_AU3
;~ 	SendMessage($aSciLexer[0], $SCI_STYLECLEARALL, 0, 0)
;~ 	Local $default_style = "0x000000,0xFFFFFF,10,Verdana,0,0,0"

	SetStyle($aSciLexer[0], $STYLE_DEFAULT, "0x000000,0xFFFFFF,10,Courier New,0,0,0")
	Local $f = __SciLexer_Find_SciTEfile("\SciTE\Properties\au3.keywords.properties", @ScriptDir) ; SciTEUser.properties
	If @error Then $f = __SciLexer_Find_SciTEfile("\SciTE\Properties\au3.keywords.properties", @ScriptDir) ; SciTEUser.properties
	If @error Then $f = __SciLexer_Find_SciTEfile("\SciTE\Properties\au3.keywords.properties", EnvGet("ProgramFiles(x86)") & "\AutoIt3")
	If @error Then $f = __SciLexer_Find_SciTEfile("\SciTE\Properties\au3.keywords.properties", EnvGet("ProgramFiles") & "\AutoIt3")
	__SciLexer_pull_keywords($aSciLexer[0], $f)

	$f = __SciLexer_Find_SciTEfile("\Local\AutoIt v3\SciTE\SciTEUser.properties", @AppDataDir)
	If @error Then $f = __SciLexer_Find_SciTEfile("\SciTEUser.properties", EnvGet("USERPROFILE"))
	If @error Then $f = __SciLexer_Find_SciTEfile("\AutoIt v3\SciTE\SciTEUser.properties", @AppDataDir)
	If @error Then $f = __SciLexer_Find_SciTEfile("\SciTE\SciTEConfig\SciTE4AutoIt3.SciTEConfig", @ScriptDir)
	__SciLexer_pull_properties($aSciLexer[0], $f) ; "\SciTEUser.properties"

	Return SetError(0, 0, $aSciLexer)
EndFunc   ;==>__SciLexer_Create

Func __SciLexer_Find_SciTEfile($filename, $sPathDown)
	While Not FileExists($sPathDown & $filename)
		$sPathDown = StringLeft($sPathDown, StringInStr($sPathDown, "\", 0, -1) - 1)
		If Not StringInStr($sPathDown, "\") Then Return SetError(1, 1, "FoundNothing")
	WEnd
	If FileExists($sPathDown & $filename) Then Return SetError(0, 0, $sPathDown & $filename)
	Return SetError(1, 2, "FoundNothing")
EndFunc   ;==>__SciLexer_Find_SciTEfile


Func __SciLexer_pull_properties($Sci, $sFilename)
	Local $s = FileRead($sFilename)
	Local $a = StringSplit($s, @CRLF, 1)
	Local $b[$a[0] + 1][3]
	$b[0][0] = 0
	For $n = 1 To $a[0]
		If $a[$n] = "" Then ContinueLoop
		$b[0][0] = $b[0][0] + 1
		$b[$b[0][0]][0] = $a[$n]
	Next
	ReDim $b[$b[0][0] + 1][3]
	$a = $b

	Local $m, $c, $sFont = "", $sSize = ""
	For $n = 1 To $a[0][0]
		If StringLeft(StringStripWS($a[$n][0], 3), 5) <> "font." Then ContinueLoop
		If StringInStr($a[$n][0], "$(font.override)") And StringInStr($a[$n][0], "font.base") Then ContinueLoop
		If Not (StringInStr($a[$n][0], "font.base") Or StringInStr($a[$n][0], "font.monospace")) Then ContinueLoop
		Local $c = StringSplit($a[$n][0], "=:,", 0)
		For $m = 1 To $c[0] - 1
			If $c[$m] = "font" Then $sFont = $c[$m + 1]
			If $c[$m] = "size" Then $sSize = $c[$m + 1]
		Next
		If $sFont <> "" And $sSize <> "" Then
			SetStyle($Sci, $STYLE_DEFAULT, "0x000000,0xFFFFFF," & $sSize & "," & $sFont & ",0,0,0")
		;	ConsoleWrite('+++ $sFont >' & $sFont & '< - $sSize >' & $sSize & '<' & @CRLF)
		EndIf
		ExitLoop
	Next

	Local $b[$a[0][0] + 1][3]
	$b[0][0] = 0
	For $n = 1 To $a[0][0]
		If StringLeft(StringStripWS($a[$n][0], 3), 6) <> "style." Then ContinueLoop
		__SciLexer_SetStyle($Sci, $a[$n][0])
	Next
EndFunc   ;==>__SciLexer_pull_properties

Func __SciLexer_SetStyle($Sci, $s)
	;ConsoleWrite(@CRLF & '+ Func __SciLexer_SetStyle("' & $s & '")' & @CRLF)
	Local $a = StringSplit($s, "=")
	If UBound($a) < 2 Then Return
	Local $b = StringSplit($a[$a[0] - 1], ".")
	If UBound($b) < 2 Then Return
	Local $c, $n, $i = Int($b[$b[0]])
	;ConsoleWrite("--- index: " & $i & @CRLF)
	;ConsoleWrite($a[$a[0]]&@CRLF)
	$b = StringSplit(StringStripWS($a[$a[0]], 8), ",")
	For $n = 1 To $b[0]
		;ConsoleWrite($n&@TAB&$b[$n]&@CRLF)
		If StringInStr($b[$n], ":#") Then
			$c = StringSplit($b[$n], ":#", 1)
			If $c[1] = "fore" Then SendMessage($Sci, $SCI_STYLESETFORE, $i, _Rev("0x" & $c[2]))
			If $c[1] = "back" Then SendMessage($Sci, $SCI_STYLESETBACK, $i, _Rev("0x" & $c[2]))
		;	If $i = 32 Then ConsoleWrite("! " & $b[$n] & @CRLF)
			ContinueLoop
		EndIf
		If $b[$n] = "italics" Then SendMessage($Sci, $SCI_STYLESETITALIC, $i, 1)
		If $b[$n] = "bold" Then SendMessage($Sci, $SCI_STYLESETBOLD, $i, 1)
		If $b[$n] = "underlined" Then SendMessage($Sci, $SCI_STYLESETUNDERLINE, $i, 1)
	Next
EndFunc   ;==>__SciLexer_SetStyle

; #FUNCTION# ====================================================================================================================
; Name ..........: _Rev
; Description ...: Reverses the color bits
; Syntax ........: _Rev($iColor)
; Parameters ....: $iColor              - Hex color value.
; Return values .: None
; Author ........: Trancexx
; Modified ......: ApudAngelorum
; ===============================================================================================================================
Func _Rev($Color)
	If IsString($Color) Then Return Dec(Hex(BinaryMid(Dec(StringReplace($Color, "0x", "")), 1, 3)))
	Return Dec(Hex(BinaryMid($Color, 1, 3)))
EndFunc   ;==>_Rev

Func __SciLexer_pull_keywords($Sci, $sFilename)
	Local $s = FileRead($sFilename)
	Local $a = StringSplit($s, @CRLF)
	Local $n
	Local $b[$a[0] + 1][3]
	$b[0][0] = 0
	For $n = 1 To $a[0]
		If StringLeft(StringStripWS($a[$n], 3), 1) = ";" Then ContinueLoop
		If StringInStr($a[$n], "au3.keywords.") Then
		;	ConsoleWrite("!" & @CRLF)
			$b[0][0] = $b[0][0] + 1
			$b[$b[0][0]][0] = StringMid($a[$n], 14, StringInStr($a[$n], "=") - 14)
			$b[$b[0][0]][2] = StringTrimLeft($a[$n], StringInStr($a[$n], "="))
			If StringRight($b[$b[0][0]][2], 1) = "\" Then $b[$b[0][0]][2] = StringTrimRight($b[$b[0][0]][2], 1)
			ContinueLoop
		EndIf
		If Not $b[0][0] Then ContinueLoop
		If $a[$n] = "" Then ContinueLoop
		$b[$b[0][0]][2] = StringStripWS($b[$b[0][0]][2], 7) & " " & StringStripWS($a[$n], 7)
		If StringRight($b[$b[0][0]][2], 1) = "\" Then $b[$b[0][0]][2] = StringTrimRight($b[$b[0][0]][2], 1)
	Next
	ReDim $b[$b[0][0] + 1][3]
	For $n = 1 To $b[0][0]
		Switch $b[$n][0]
			Case "Keywords"
				$b[$n][1] = 0
			Case "Functions"
				$b[$n][1] = 1
			Case "Macros"
				$b[$n][1] = 2
			Case "SendKeys"
				$b[$n][1] = 3
			Case "PreProcessor"
				$b[$n][1] = 4
			Case "Special"
				$b[$n][1] = 5
			Case "UDFs"
				$b[$n][1] = 7
		EndSwitch
	Next
	For $n = 1 To $b[0][0]
		SendMessageString($Sci, $SCI_SETKEYWORDS, $b[$n][1], $b[$n][2])
	Next
EndFunc   ;==>__SciLexer_pull_keywords

Func SendMessageString($Sci, $msg, $wp, $str)
	;	ConsoleWrite('+ Func SendMessageString('&$Sci&', '&$msg&', '&$wp&', "'&$str&'")'&@CRLF)
	Local $ret
	$ret = DllCall($user32dll, "int", "SendMessageA", "hwnd", $Sci, "int", $msg, "int", $wp, "str", $str)
	Return $ret[0]
EndFunc   ;==>SendMessageString

Func SendMessage($Sci, $msg, $wp, $lp)
	;	ConsoleWrite('+ Func SendMessage(' & $Sci & ', ' & $msg & ', ' & $wp & ', ' & $lp & ' )' & @CRLF)
	Local $ret
	$ret = DllCall($user32dll, "long", "SendMessageA", "long", $Sci, "int", $msg, "int", $wp, "int", $lp)
	Return $ret[0]
EndFunc   ;==>SendMessage

Func SetStyle($Sci, $style, $styletxt)
	Local $astyle = StringSplit($styletxt, ",")

	If UBound($astyle) < 8 Then
		;MsgBox(16,"Warning","Incomplete style definition, skipping..."&@CRLF&$styletxt)
		Return
	EndIf

	SendMessage($Sci, $SCI_STYLESETFORE, $style, $astyle[1])
	SendMessage($Sci, $SCI_STYLESETBACK, $style, $astyle[2])
	If $astyle[3] >= 1 Then
		SendMessage($Sci, $SCI_STYLESETSIZE, $style, $astyle[3])
	EndIf
	If $astyle[4] <> '' Then
		SendMessageString($Sci, $SCI_STYLESETFONT, $style, $astyle[4])
	EndIf
	SendMessage($Sci, $SCI_STYLESETBOLD, $style, $astyle[5])
	SendMessage($Sci, $SCI_STYLESETITALIC, $style, $astyle[6])
	SendMessage($Sci, $SCI_STYLESETUNDERLINE, $style, $astyle[7])
EndFunc   ;==>SetStyle

Func SciAppendText($hWnd, $text)
	SendMessageString($hWnd, $SCI_APPENDTEXT, StringLen($text), $text)
EndFunc   ;==>SciAppendText
Func SciClearAll($hWnd)
	SendMessageString($hWnd, $SCI_CLEARALL, 0, 0)
EndFunc   ;==>SciClearAll
Func _Sci_GetText($Sci)
	Local $sText
	Local $iLen = SendMessage($Sci, $SCI_GETTEXT, 0, 0)
	If @error Then Return 0
	Local $sBuf = DllStructCreate("byte[" & $iLen & "]")
	If @error Then Return 0
	DllCall($user32dll, "long", "SendMessageA", "long", $Sci, "int", $SCI_GETTEXT, "int", $iLen, "ptr", DllStructGetPtr($sBuf))
	If @error Then Return 0
	$sText = BinaryToString(DllStructGetData($sBuf, 1))
	$sBuf = 0
	If @error Then Return 0
	Return StringTrimRight($sText,1)
EndFunc   ;==>_Sci_GetText
Func _Sci_ClearSelection($Sci)
	Return SendMessage($Sci, 2556, 0, 0) ; Global Const $SCI_SETEMPTYSELECTION = 2556
EndFunc   ;==>_Sci_ClearSelection
Func _Sci_EmptyUndoBuffer($Sci)
	SendMessage($Sci, 2175, 0, 0) ; Global Const $SCI_EMPTYUNDOBUFFER = 2175
EndFunc   ;==>_Sci_EmptyUndoBuffer