#include-once

; this function creates the HTML page you see on the browser,
; you can safely remove this file, as the program has a default HTML page generator

; or modify it to your like, as long as the the arguments to the function remains the same, and those are:
; $a				--- the array with the data to build the table from
; $orientation		--- 0 for Horizontal, 1 for Vertical orientation
; $sSelectedClass	--- the WMI Class used in the query, that in this case is used for the title and a headder

Func _Array2D_toHtml(ByRef $a, $orientation = 0, $sSelectedClass = "")
	Local $u1 = UBound($a, 1) - 1
	If @error Then Return SetError(1, 1, "")
	Local $sOut = '<html><head><meta http-equiv="Content-Type" content="text/html; charset=windows-1252"><title>ScriptOMatic - ' & $sSelectedClass & '</title></head><body bgcolor="#EEEEEE">'
	$sOut &= $sSelectedClass
	$sOut &= '<br><br>this page was generated from "_Array2D_toHtml.au3"<br>you can change it or remove it. Have fun.<br><br>'
	$sOut &= '<table border="1" width="100%" cellspacing="0">' & @CRLF
	Local $iFlipFlop = True
	Local $aFlipFlop[2] = ['style="background-color:#6BB1F2;" ', 'style="background-color:#6BC9F2;"']
	Local $headderItStart = "", $headderItEnd = ""
	Local $u2 = UBound($a, 2) - 1
	If @error Then
		Local $n, $m, $u2 = 1
		Local $b[$u2][$u1 + 1]
		For $n = 0 To $u1
			$sOut &= "<tr>"
			If Not $orientation Then
				$iFlipFlop = Not $iFlipFlop
			Else
				If Not $n Then
					$headderItStart = "<i><u>"
					$headderItEnd = "</u></i>"
				Else
					$headderItStart = ""
					$headderItEnd = ""
				EndIf
			EndIf
			For $m = 0 To 0
				If $orientation Then
					If Not $m Then
						$iFlipFlop = True
					EndIf
					$iFlipFlop = Not $iFlipFlop
				Else
					If Not $m Then
						$headderItStart = "<i><u>"
						$headderItEnd = "</u></i>"
					Else
						$headderItStart = ""
						$headderItEnd = ""
					EndIf
				EndIf
				$sOut &= '<td ' & $aFlipFlop[($iFlipFlop)] & '>' & $headderItStart & $a[$n] & $headderItEnd & '</td>'
			Next
			$sOut &= "</tr>" & @CRLF
		Next
	Else
		Local $n, $m
		Local $b[$u2 + 1][$u1 + 1]
		For $n = 0 To $u1
			$sOut &= "<tr>"
			If Not $orientation Then
				$iFlipFlop = Not $iFlipFlop
			Else
				If Not $n Then
					$headderItStart = "<b>"
					$headderItEnd = "</b>"
				Else
					$headderItStart = ""
					$headderItEnd = ""
				EndIf
			EndIf
			For $m = 0 To $u2
				If $orientation Then
					If Not $m Then
						$iFlipFlop = True
					EndIf
					$iFlipFlop = Not $iFlipFlop
				Else
					If Not $m Then
						$headderItStart = "<b>"
						$headderItEnd = "</b>"
					Else
						$headderItStart = ""
						$headderItEnd = ""
					EndIf
				EndIf
				$sOut &= '<td ' & $aFlipFlop[($iFlipFlop)] & '>' & $headderItStart & $a[$n][$m] & $headderItEnd & '</td>'
			Next
			$sOut &= "</tr>" & @CRLF
		Next
	EndIf
	$sOut &= "</table>" & @CRLF
	$sOut &= '</body></html>' & @CRLF
	Return SetError(0, 0, $sOut)
EndFunc   ;==>_Array2D_toHtml